/* This utility converts special ImageMagick-converted xpm files to ANSI format.
   Assuming that convert was called with the "-color 40" option.
   Please note that other XPM files cannot be converted with this tool.
   Author: Kov\'acs, Zolt\'an, kovzol@math.u-szeged.hu.
*/

#define VERSION 0
#define SUBVERSION 1
// maximal size of loaded strings
#define MAXS 1000
// maximal number of colors
#define MAXC 1000

char col[MAXC]; // character for a color
char rgb[MAXC][9]; // RGB code
char ansicol[MAXC][2]; // ANSI code

int rgb2ansi_back(const char *rgb)
// translates #abcdef like rgb input to a 0 <= ansi color <= 7 number
// should handle Gray* codes
// background code
{
    int col=0;
    int i;
    for (i=5;i>0;i-=2)
    {
	col*=2;
    	if (rgb[i]>'8')
	    ++col;
    }
    return col;
}

int rgb2ansi_text(const char *rgb)
// translates #abcdef like rgb input to a 0 <= ansi color <= 7 number
// should handle Gray* codes
// foreground code
{
    int col=0;
    int i;
    for (i=6;i>1;i-=2)
    {
	col*=2;
    	if (rgb[i]>'8')
	    ++col;
    }
    return col;
}

main()
{
    char s[MAXS],sw[MAXS],sh[MAXS],sc[MAXS];
    int w,h,c ,i,j,k;
    scanf("%s %s %s",&s,&s,&s);
    scanf("%s %s %s",&s,&s,&s);
    scanf("%s %s %s",&s,&s,&s);
    scanf("%s %s %s",&s,&s,&s,&s);
    scanf("%s %s %c",&s,&s,&s);
    scanf("%s %s %s %s",&sw,&sh,&sc,&s);
    w=atoi(sw);
    h=atoi(sh);
    c=atoi(sc);

    gets(s);
    for (i=0;i<c;++i)
    {
	gets(s);
	col[i]=s[1];
	for (j=5;j<12;++j)
	    rgb[i][j-5]=s[j];
	ansicol[i][0]=rgb2ansi_back(rgb[i]);
	ansicol[i][1]=rgb2ansi_text(rgb[i]);
    }
    
    scanf("%s %s %s",&s,&s,&s);

    gets(s);
    for (i=0;i<h;++i)
    {
	gets(s);
	for (j=0;j<w;++j)
	{
	    for (k=0;k<c;++k)
		if (col[k]==s[j+1])
		    printf("\033[4%dm\033[3%dm",ansicol[k][0],ansicol[k][1]);
//	    printf("%c",(char)s[j+1]);
	    printf("+");

	}
	printf("\033[00m\n");
    }
}
